Index: /XIOS/trunk/src/event_client.cpp
===================================================================
--- /XIOS/trunk/src/event_client.cpp	(revision 1536)
+++ /XIOS/trunk/src/event_client.cpp	(revision 1537)
@@ -5,4 +5,5 @@
 #include "type.hpp"
 #include "mpi.hpp"
+#include "cxios.hpp"
 
 namespace xios
@@ -49,4 +50,5 @@
      std::list<CMessage*>::iterator itMsg = messages.begin();
 
+     if (CXios::checkEventSync) info(100)<<"Send event "<<timeLine<<" classId : "<<classId<<"  typeId : "<<typeId<<endl ;
      for (; itBuff != buffers.end(); ++itBuff, ++itSizes, ++itSenders, ++itMsg)
      {
Index: /XIOS/trunk/src/event_client.hpp
===================================================================
--- /XIOS/trunk/src/event_client.hpp	(revision 1536)
+++ /XIOS/trunk/src/event_client.hpp	(revision 1537)
@@ -21,5 +21,7 @@
       std::list<int> getRanks(void);
       std::list<int> getSizes(void);
-
+      int getClassId(void) { return classId; }
+      int getTypeId(void) { return typeId; }
+      
     private:
       int classId;
Index: /XIOS/trunk/src/event_scheduler.cpp
===================================================================
--- /XIOS/trunk/src/event_scheduler.cpp	(revision 1536)
+++ /XIOS/trunk/src/event_scheduler.cpp	(revision 1537)
@@ -2,4 +2,5 @@
 #include "xios_spl.hpp"
 #include "mpi.hpp"
+#include "tracer.hpp"
 
 namespace xios
@@ -80,4 +81,5 @@
   {
        
+    traceOff() ;
     SPendingRequest* sentRequest=new SPendingRequest ;
     sentRequest->buffer[0]=timeLine ;
@@ -87,4 +89,5 @@
     pendingSentParentRequest.push(sentRequest) ;
     MPI_Isend(sentRequest->buffer,3, MPI_UNSIGNED_LONG, parent[lev], 0, communicator, &sentRequest->request) ;
+    traceOn() ;
   } 
 
@@ -102,10 +105,10 @@
   void CEventScheduler::checkEvent(void)
   {
+    traceOff() ;
     checkChildRequest() ;
     checkParentRequest() ;
-    
-  }
-  
-  
+    traceOn() ;
+    
+  }
   
   void CEventScheduler::checkParentRequest(void)
Index: /XIOS/trunk/src/filter/file_server_writer_filter.cpp
===================================================================
--- /XIOS/trunk/src/filter/file_server_writer_filter.cpp	(revision 1537)
+++ /XIOS/trunk/src/filter/file_server_writer_filter.cpp	(revision 1537)
@@ -0,0 +1,30 @@
+#include "file_server_writer_filter.hpp"
+#include "exception.hpp"
+#include "field.hpp"
+
+namespace xios
+{
+  CFileServerWriterFilter::CFileServerWriterFilter(CGarbageCollector& gc, CField* field)
+    : CInputPin(gc, 1)
+    , field(field)
+  {
+    if (!field)
+      ERROR("CFileServerWriterFilter::CFileServerWriterFilter(CField* field)",
+            "The field cannot be null.");
+  }
+
+  void CFileServerWriterFilter::onInputReady(std::vector<CDataPacketPtr> data)
+  {
+    field->writeUpdateData(data[0]->data);
+  }
+
+  bool CFileServerWriterFilter::mustAutoTrigger() const
+  {
+    return true;
+  }
+
+  bool CFileServerWriterFilter::isDataExpected(const CDate& date) const
+  {
+    return true;
+  }
+} // namespace xios
Index: /XIOS/trunk/src/filter/file_server_writer_filter.hpp
===================================================================
--- /XIOS/trunk/src/filter/file_server_writer_filter.hpp	(revision 1537)
+++ /XIOS/trunk/src/filter/file_server_writer_filter.hpp	(revision 1537)
@@ -0,0 +1,53 @@
+#ifndef __XIOS_CFileServerWriterFilter__
+#define __XIOS_CFileServerWriterFilter__
+
+#include "input_pin.hpp"
+
+namespace xios
+{
+  class CField;
+
+  /*!
+   * A terminal filter which writes the packets it receives in a file.
+   */
+  class CFileServerWriterFilter : public CInputPin
+  {
+    public:
+      /*!
+       * Constructs the filter (with one input slot) associated to the specified field
+       * and a garbage collector.
+       *
+       * \param gc the associated garbage collector
+       * \param field the associated field
+       */
+      CFileServerWriterFilter(CGarbageCollector& gc, CField* field);
+
+      /*!
+       * Tests if the filter must auto-trigger.
+       *
+       * \return true if the filter must auto-trigger
+       */
+      bool virtual mustAutoTrigger() const;
+
+      /*!
+       * Tests whether data is expected for the specified date.
+       *
+       * \param date the date associated to the data
+       */
+      bool virtual isDataExpected(const CDate& date) const;
+
+    protected:
+      /*!
+       * Callbacks a field to write a packet to a file.
+       *
+       * \param data a vector of packets corresponding to each slot
+       */
+      void virtual onInputReady(std::vector<CDataPacketPtr> data);
+
+    private:
+      CField* field; //<! The associated field
+      std::map<Time, CDataPacketPtr> packets; //<! The stored packets
+  }; // class CFileServerWriterFilter
+} // namespace xios
+
+#endif //__XIOS_CFileServerWriterFilter__
Index: /XIOS/trunk/src/filter/source_filter.cpp
===================================================================
--- /XIOS/trunk/src/filter/source_filter.cpp	(revision 1536)
+++ /XIOS/trunk/src/filter/source_filter.cpp	(revision 1537)
@@ -7,5 +7,5 @@
 namespace xios
 {
-  CSourceFilter::CSourceFilter(CGarbageCollector& gc, CGrid* grid,
+  CSourceFilter::CSourceFilter(CGarbageCollector& gc, CGrid* grid, bool compression, 
                                const CDuration offset /*= NoneDu*/, bool manualTrigger /*= false*/,
                                bool hasMissingValue /*= false*/,
@@ -13,4 +13,5 @@
     : COutputPin(gc, manualTrigger)
     , grid(grid)
+    , compression(compression)
     , offset(offset)
     , hasMissingValue(hasMissingValue), defaultValue(defaultValue)
@@ -31,7 +32,24 @@
     packet->status = CDataPacket::NO_ERROR;
 
-    packet->data.resize(grid->storeIndex_client.numElements());
-    grid->inputField(data, packet->data);
+    packet->data.resize(grid->storeIndex_client.numElements());    
+    
+    if (compression)
+    {
+      packet->data = defaultValue;
+      grid->uncompressField(data, packet->data);    
+    }
+    else
+      grid->inputField(data, packet->data);
 
+    
+    
+    // if (compression) grid->inputField(data, packet->data) ;
+    // else
+    // {
+    //   // just make a flat copy
+    //   CArray<double, N> data_tmp(data.copy()) ; // supress const attribute
+    //   CArray<double,1> dataTmp2(data_tmp.dataFirst(),shape(data.numElements()),neverDeleteData) ;
+    //   packet->data = dataTmp2 ;
+    // }
     // Convert missing values to NaN
     if (hasMissingValue)
@@ -65,6 +83,5 @@
     packet->timestamp = date;
     packet->status = CDataPacket::NO_ERROR;
-
-    // if (data.size() != grid->storeIndex_toSrv.size())
+    
     if (data.size() != grid->storeIndex_fromSrv.size())
       ERROR("CSourceFilter::streamDataFromServer(CDate date, const std::map<int, CArray<double, 1> >& data)",
@@ -75,6 +92,5 @@
     std::map<int, CArray<double, 1> >::const_iterator it, itEnd = data.end();
     for (it = data.begin(); it != itEnd; it++)
-    {
-      // CArray<int,1>& index = grid->storeIndex_toSrv[it->first];
+    {      
       CArray<int,1>& index = grid->storeIndex_fromSrv[it->first];
       for (int n = 0; n < index.numElements(); n++)
Index: /XIOS/trunk/src/filter/source_filter.hpp
===================================================================
--- /XIOS/trunk/src/filter/source_filter.hpp	(revision 1536)
+++ /XIOS/trunk/src/filter/source_filter.hpp	(revision 1537)
@@ -27,4 +27,5 @@
        */
       CSourceFilter(CGarbageCollector& gc, CGrid* grid,
+                    bool compression=true,
                     const CDuration offset = NoneDu, bool manualTrigger = false,
                     bool hasMissingValue = false,
@@ -64,4 +65,5 @@
       const bool hasMissingValue;
       const double defaultValue;
+      const bool compression ; //!< indicate if the data need to be compressed : on client size : true, on server side : false
   }; // class CSourceFilter
 } // namespace xios
Index: /XIOS/trunk/src/filter/spatial_transform_filter.cpp
===================================================================
--- /XIOS/trunk/src/filter/spatial_transform_filter.cpp	(revision 1536)
+++ /XIOS/trunk/src/filter/spatial_transform_filter.cpp	(revision 1537)
@@ -3,4 +3,5 @@
 #include "context.hpp"
 #include "context_client.hpp"
+#include "timer.hpp"
 
 namespace xios
@@ -27,6 +28,17 @@
       size_t inputCount = 1 + (auxInputs.empty() ? 0 : auxInputs.size());
       double defaultValue  = (hasMissingValue) ? std::numeric_limits<double>::quiet_NaN() : 0.0;
-      boost::shared_ptr<CSpatialTransformFilter> filter(new CSpatialTransformFilter(gc, engine, defaultValue, inputCount));
-
+
+
+      const CGridTransformationSelector::ListAlgoType& algoList = gridTransformation->getAlgoList() ;
+      CGridTransformationSelector::ListAlgoType::const_iterator it  ;
+
+      bool isSpatialTemporal=false ;
+      for (it=algoList.begin();it!=algoList.end();++it)  if (it->second.first == TRANS_TEMPORAL_SPLITTING) isSpatialTemporal=true ;
+
+      boost::shared_ptr<CSpatialTransformFilter> filter ;
+      if( isSpatialTemporal) filter = boost::shared_ptr<CSpatialTransformFilter>(new CSpatialTemporalFilter(gc, engine, gridTransformation, defaultValue, inputCount));
+      else filter = boost::shared_ptr<CSpatialTransformFilter>(new CSpatialTransformFilter(gc, engine, defaultValue, inputCount));
+
+      
       if (!lastFilter)
         lastFilter = filter;
@@ -57,4 +69,67 @@
   }
 
+
+
+
+
+  CSpatialTemporalFilter::CSpatialTemporalFilter(CGarbageCollector& gc, CSpatialTransformFilterEngine* engine, CGridTransformation* gridTransformation, double outputValue, size_t inputSlotsCount)
+    : CSpatialTransformFilter(gc, engine, outputValue, inputSlotsCount), record(0)
+  {
+      const CGridTransformationSelector::ListAlgoType& algoList = gridTransformation->getAlgoList() ;
+      CGridTransformationSelector::ListAlgoType::const_iterator it  ;
+
+      int pos ;
+      for (it=algoList.begin();it!=algoList.end();++it) 
+        if (it->second.first == TRANS_TEMPORAL_SPLITTING)
+        {
+          pos=it->first ;
+          if (pos < algoList.size()-1)
+            ERROR("SpatialTemporalFilter::CSpatialTemporalFilter(CGarbageCollector& gc, CSpatialTransformFilterEngine* engine, CGridTransformation* gridTransformation, double outputValue, size_t inputSlotsCount))",
+                  "temporal splitting operation must be the last of whole transformation on same grid") ;
+        }
+          
+      CGrid* grid=gridTransformation->getGridDestination() ;
+
+      CAxis* axis = grid->getAxis(gridTransformation->getElementPositionInGridDst2AxisPosition().find(pos)->second) ;
+
+      nrecords = axis->index.numElements() ;
+  }
+
+
+  void CSpatialTemporalFilter::onInputReady(std::vector<CDataPacketPtr> data)
+  {
+    CSpatialTransformFilterEngine* spaceFilter = static_cast<CSpatialTransformFilterEngine*>(engine);
+    CDataPacketPtr outputPacket = spaceFilter->applyFilter(data, outputDefaultValue);
+
+    if (outputPacket)
+    {
+      size_t nelements=outputPacket->data.numElements() ;
+      if (!tmpData.numElements())
+      {
+        tmpData.resize(nelements);
+        tmpData=outputDefaultValue ;
+      }
+
+      nelements/=nrecords ;
+      size_t offset=nelements*record ;
+      for(size_t i=0;i<nelements;++i)  tmpData(i+offset) = outputPacket->data(i) ;
+    
+      record ++ ;
+      if (record==nrecords)
+      {
+        record=0 ;
+        CDataPacketPtr packet = CDataPacketPtr(new CDataPacket);
+        packet->date = data[0]->date;
+        packet->timestamp = data[0]->timestamp;
+        packet->status = data[0]->status;
+        packet->data.resize(tmpData.numElements());
+        packet->data = tmpData;
+        onOutputReady(packet);
+        tmpData.resize(0) ;
+      }
+    }
+  }
+
+
   CSpatialTransformFilterEngine::CSpatialTransformFilterEngine(CGridTransformation* gridTransformation)
     : gridTransformation(gridTransformation)
@@ -114,4 +189,6 @@
   void CSpatialTransformFilterEngine::apply(const CArray<double, 1>& dataSrc, CArray<double,1>& dataDest)
   {
+    CTimer::get("CSpatialTransformFilterEngine::apply").resume(); 
+    
     CContextClient* client = CContext::getCurrent()->client;
 
@@ -228,4 +305,6 @@
 
     dataDest = dataCurrentDest;
+
+    CTimer::get("CSpatialTransformFilterEngine::apply").suspend() ;
   }
 } // namespace xios
Index: /XIOS/trunk/src/filter/spatial_transform_filter.hpp
===================================================================
--- /XIOS/trunk/src/filter/spatial_transform_filter.hpp	(revision 1536)
+++ /XIOS/trunk/src/filter/spatial_transform_filter.hpp	(revision 1537)
@@ -49,4 +49,41 @@
       double outputDefaultValue;
   }; // class CSpatialTransformFilter
+
+
+ /*!
+   * A specific spatial filter for the temporal_splitting transformation scalar -> axis. An incoming flux will be stored in an aditional dimension given by the destination axis.
+   * At each flux received, the storing index (record) is increased. When it reach the size of the axis (nrecords) a new flux is generated and the record is reset to 0
+   */
+
+ class CSpatialTemporalFilter : public CSpatialTransformFilter
+  {
+    public:
+      /*!
+       * Constructs a filter wrapping the specified spatial transformation.
+       *
+       * \param gc the associated garbage collector
+       * \param engine the engine defining the spatial transformation
+       * \param [in] gridTransformation the associated transformations
+       * \param outputValue default value of output pin
+       * \param [in] inputSlotsCount number of input, by default there is only one for field src
+       */
+      CSpatialTemporalFilter(CGarbageCollector& gc, CSpatialTransformFilterEngine* engine, CGridTransformation* gridTransformation, double outputValue, size_t inputSlotsCount = 1);
+
+
+    protected:
+      /*!
+        Overriding this function to process transformations with auxillary inputs
+      */
+      void virtual onInputReady(std::vector<CDataPacketPtr> data);
+      //! Current record in the filter
+      int record ;
+      //! Maximum number of records
+      int nrecords;
+      //! Temporary storage for output flux
+      CArray<double, 1> tmpData; 
+
+
+  }; // class CSpatialTemporalFilter
+
 
   /*!
Index: /XIOS/trunk/src/filter/temporal_filter.cpp
===================================================================
--- /XIOS/trunk/src/filter/temporal_filter.cpp	(revision 1536)
+++ /XIOS/trunk/src/filter/temporal_filter.cpp	(revision 1537)
@@ -5,11 +5,11 @@
 namespace xios
 {
-  static func::CFunctor* createFunctor(const std::string& opId, bool ignoreMissingValue, double missingValue, CArray<double, 1>& tmpData);
+  static func::CFunctor* createFunctor(const std::string& opId, bool ignoreMissingValue, CArray<double, 1>& tmpData);
 
   CTemporalFilter::CTemporalFilter(CGarbageCollector& gc, const std::string& opId,
                                    const CDate& initDate, const CDuration samplingFreq, const CDuration samplingOffset, const CDuration opFreq,
-                                   bool ignoreMissingValue /*= false*/, double missingValue /*= 0.0*/)
+                                   bool ignoreMissingValue /*= false*/)
     : CFilter(gc, 1, this)
-    , functor(createFunctor(opId, ignoreMissingValue, missingValue, tmpData))
+    , functor(createFunctor(opId, ignoreMissingValue, tmpData))
     , isOnceOperation(functor->timeType() == func::CFunctor::once)
     , isInstantOperation(functor->timeType() == func::CFunctor::instant)
@@ -17,6 +17,14 @@
     , samplingOffset(samplingOffset)
     , opFreq(opFreq)
-    , nextSamplingDate(initDate + this->samplingOffset + initDate.getRelCalendar().getTimeStep())
-    , nextOperationDate(initDate + this->samplingOffset + opFreq)
+    , offsetMonth(0, this->samplingOffset.month, 0, 0, 0, 0, 0)
+    , offsetAllButMonth(this->samplingOffset.year, 0 , this->samplingOffset.day,
+                        this->samplingOffset.hour, this->samplingOffset.minute,
+                        this->samplingOffset.second, this->samplingOffset.timestep)
+    , initDate(initDate)
+//    , nextSamplingDate(initDate + (this->samplingOffset + initDate.getRelCalendar().getTimeStep()))
+    , nextSamplingDate(initDate + offsetMonth + ( offsetAllButMonth + initDate.getRelCalendar().getTimeStep()))
+    , nbOperationDates(1)
+    , nbSamplingDates(0)
+//    , nextOperationDate(initDate + opFreq + this->samplingOffset)
     , isFirstOperation(true)
   {
@@ -35,5 +43,6 @@
       {
         usePacket = (data[0]->date >= nextSamplingDate);
-        outputResult = (data[0]->date + samplingFreq > nextOperationDate);
+//        outputResult = (data[0]->date + samplingFreq > nextOperationDate);
+        outputResult = (data[0]->date  > initDate + nbOperationDates*opFreq - samplingFreq + offsetMonth + offsetAllButMonth);
         copyLess = (isInstantOperation && usePacket && outputResult);
       }
@@ -41,4 +50,5 @@
       if (usePacket)
       {
+        nbSamplingDates ++;
         if (!copyLess)
         {
@@ -49,9 +59,10 @@
         }
 
-        nextSamplingDate = nextSamplingDate + samplingFreq;
+        nextSamplingDate = ((initDate + offsetMonth) + nbSamplingDates * samplingFreq) + offsetAllButMonth + initDate.getRelCalendar().getTimeStep();
       }
 
       if (outputResult)
       {
+        nbOperationDates ++;
         if (!copyLess)
         {
@@ -69,5 +80,5 @@
 
         isFirstOperation = false;
-        nextOperationDate = nextOperationDate + samplingFreq + opFreq - samplingFreq;
+//        nextOperationDate = initDate + samplingFreq + nbOperationDates*opFreq - samplingFreq + offsetMonth + offsetAllButMonth;
       }
     }
@@ -83,12 +94,13 @@
   bool CTemporalFilter::isDataExpected(const CDate& date) const
   {
-    return isOnceOperation ? isFirstOperation : (date >= nextSamplingDate || date + samplingFreq > nextOperationDate);
+//    return isOnceOperation ? isFirstOperation : (date >= nextSamplingDate || date + samplingFreq > nextOperationDate);
+    return isOnceOperation ? isFirstOperation : (date >= nextSamplingDate || date > initDate + nbOperationDates*opFreq - samplingFreq + offsetMonth + offsetAllButMonth);
   }
 
-  static func::CFunctor* createFunctor(const std::string& opId, bool ignoreMissingValue, double missingValue, CArray<double, 1>& tmpData)
+  static func::CFunctor* createFunctor(const std::string& opId, bool ignoreMissingValue, CArray<double, 1>& tmpData)
   {
     func::CFunctor* functor = NULL;
 
-    double defaultValue = ignoreMissingValue ? std::numeric_limits<double>::quiet_NaN() : missingValue;
+    double defaultValue = std::numeric_limits<double>::quiet_NaN();
 
 #define DECLARE_FUNCTOR(MType, mtype) \
Index: /XIOS/trunk/src/filter/temporal_filter.hpp
===================================================================
--- /XIOS/trunk/src/filter/temporal_filter.hpp	(revision 1536)
+++ /XIOS/trunk/src/filter/temporal_filter.hpp	(revision 1537)
@@ -26,9 +26,8 @@
        * \param ignoreMissingValue true if and only if the missing value must be ignored
                                    when doing the operation
-       * \param missingValue the missing value
        */
       CTemporalFilter(CGarbageCollector& gc, const std::string& opId,
                       const CDate& initDate, const CDuration samplingFreq, const CDuration samplingOffset, const CDuration opFreq,
-                      bool ignoreMissingValue = false, double missingValue = 0.0);
+                      bool ignoreMissingValue = false);
 
       /*!
@@ -63,6 +62,11 @@
       const CDuration samplingOffset; //!< The sampling offset, i.e. the offset after which the input data will be used
       const CDuration opFreq; //!< The operation frequency, i.e. the frequency at which the output data will be computed
+      const CDuration offsetMonth; //!< The month duration of samplingOffset
+      CDuration offsetAllButMonth; //!< All but the month duration of samplingOffset
+      const CDate initDate;
       CDate nextSamplingDate; //!< The date of the next sampling
-      CDate nextOperationDate; //!< The date of the next operation
+      int nbOperationDates; //!< The number of times an operation is performed
+      int nbSamplingDates;
+//      CDate nextOperationDate; //!< The date of the next operation
       bool isFirstOperation; //!< True before the first operation was been computed
   }; // class CTemporalFilter
Index: /XIOS/trunk/src/generate_fortran_interface.cpp
===================================================================
--- /XIOS/trunk/src/generate_fortran_interface.cpp	(revision 1536)
+++ /XIOS/trunk/src/generate_fortran_interface.cpp	(revision 1537)
@@ -35,4 +35,5 @@
   CComputeConnectivityDomain compConDomain;
   CExpandDomain expandDomain;
+  CReorderDomain reorderDomain;
 
   CInterpolateAxis interpolateAxis;
@@ -40,10 +41,14 @@
   CInverseAxis inverseAxis;
   CReduceDomainToAxis reduceDomainToAxis;
+  CReduceAxisToAxis reduceAxisToAxis;
   CExtractDomainToAxis extractDomainToAxis;
+  CTemporalSplitting temporalSplitting;
 
   CReduceAxisToScalar reduceAxisToScalar;
   CExtractAxisToScalar extractAxisToScalar;
   CReduceDomainToScalar reduceDomainToScalar;
-
+  CDuplicateScalarToAxis duplicateScalarToAxis;
+  CReduceScalarToScalar reduceScalarToScalar;
+  
   ostringstream oss;
   ofstream file;
@@ -297,4 +302,17 @@
   file.open((path+"iexpand_domain_attr.F90").c_str());
   expandDomain.generateFortranInterface(file);
+  file.close();
+
+  file.open((path+"reorder_domain_interface_attr.F90").c_str());
+  reorderDomain.generateFortran2003Interface(file);
+  file.close();
+
+  file.open((path+"icreorder_domain_attr.cpp").c_str());
+  reorderDomain.generateCInterface(file);
+  file.close();
+
+  file.open((path+"ireorder_domain_attr.F90").c_str());
+  reorderDomain.generateFortranInterface(file);
+
   file.close();
   
@@ -341,5 +359,5 @@
   reduceDomainToAxis.generateFortran2003Interface(file);
   file.close();
-
+ 
   file.open((path+"icreduce_domain_to_axis_attr.cpp").c_str());
   reduceDomainToAxis.generateCInterface(file);
@@ -348,4 +366,16 @@
   file.open((path+"ireduce_domain_to_axis_attr.F90").c_str());
   reduceDomainToAxis.generateFortranInterface(file);
+  file.close();
+
+  file.open((path+"reduce_axis_to_axis_interface_attr.F90").c_str());
+  reduceAxisToAxis.generateFortran2003Interface(file);
+  file.close();
+ 
+  file.open((path+"icreduce_axis_to_axis_attr.cpp").c_str());
+  reduceAxisToAxis.generateCInterface(file);
+  file.close();
+
+  file.open((path+"ireduce_axis_to_axis_attr.F90").c_str());
+  reduceAxisToAxis.generateFortranInterface(file);
   file.close();
   
@@ -363,4 +393,28 @@
 
 
+  file.open((path+"temporal_splitting_interface_attr.F90").c_str());
+  temporalSplitting.generateFortran2003Interface(file);
+  file.close();
+
+  file.open((path+"ictemporal_splitting_attr.cpp").c_str());
+  temporalSplitting.generateCInterface(file);
+  file.close();
+
+  file.open((path+"itemporal_splitting_attr.F90").c_str());
+  temporalSplitting.generateFortranInterface(file);
+  file.close();
+
+
+  file.open((path+"duplicate_scalar_to_axis_interface_attr.F90").c_str());
+  duplicateScalarToAxis.generateFortran2003Interface(file);
+  file.close();
+  
+  file.open((path+"icduplicate_scalar_to_axis_attr.cpp").c_str());
+  duplicateScalarToAxis.generateCInterface(file);
+  file.close();
+  
+  file.open((path+"iduplicate_scalar_to_axis_attr.F90").c_str());
+  duplicateScalarToAxis.generateFortranInterface(file);
+  file.close();
   /*!
     Scalar transformations
@@ -390,4 +444,5 @@
   file.close();
 
+
   file.open((path+"reduce_domain_to_scalar_interface_attr.F90").c_str());
   reduceDomainToScalar.generateFortran2003Interface(file);
@@ -402,4 +457,21 @@
   file.close();
 
+
+  file.open((path+"reduce_scalar_to_scalar_interface_attr.F90").c_str());
+  reduceScalarToScalar.generateFortran2003Interface(file);
+  file.close();
+
+  file.open((path+"icreduce_scalar_to_scalar_attr.cpp").c_str());
+  reduceScalarToScalar.generateCInterface(file);
+  file.close();
+
+  file.open((path+"ireduce_scalar_to_scalar_attr.F90").c_str());
+  reduceScalarToScalar.generateFortranInterface(file);
+  file.close();
+
+
+
+
+
   file.open((path+"context_interface_attr.F90").c_str());
   context->generateFortran2003Interface(file);
Index: /XIOS/trunk/src/group_factory_decl.cpp
===================================================================
--- /XIOS/trunk/src/group_factory_decl.cpp	(revision 1536)
+++ /XIOS/trunk/src/group_factory_decl.cpp	(revision 1537)
@@ -34,4 +34,5 @@
   macro(CReduceAxisToScalarGroup)
   macro(CReduceDomainToAxisGroup)
+  macro(CReduceAxisToAxisGroup)
   macro(CExtractDomainToAxisGroup)
   macro(CComputeConnectivityDomainGroup)
@@ -39,3 +40,7 @@
   macro(CExtractAxisToScalarGroup)
   macro(CReduceDomainToScalarGroup)
+  macro(CTemporalSplittingGroup)
+  macro(CDuplicateScalarToAxisGroup)
+  macro(CReduceScalarToScalarGroup)
+  macro(CReorderDomainGroup)
 }
Index: /XIOS/trunk/src/group_template.hpp
===================================================================
--- /XIOS/trunk/src/group_template.hpp	(revision 1536)
+++ /XIOS/trunk/src/group_template.hpp	(revision 1537)
@@ -6,4 +6,5 @@
 #include "event_server.hpp"
 #include "object_template.hpp"
+#include "context_client.hpp"
 
 namespace xios
@@ -72,4 +73,5 @@
          static bool dispatchEvent(CEventServer& event) ;
          void sendCreateChild(const string& id="") ;
+         void sendCreateChild(const string& id, CContextClient* client) ;
          void sendCreateChildGroup(const string& id="") ;
          static void recvCreateChild(CEventServer& event) ;
Index: /XIOS/trunk/src/group_template_decl.cpp
===================================================================
--- /XIOS/trunk/src/group_template_decl.cpp	(revision 1536)
+++ /XIOS/trunk/src/group_template_decl.cpp	(revision 1537)
@@ -23,4 +23,5 @@
   macro(ReduceAxisToScalar)
   macro(ReduceDomainToAxis)
+  macro(ReduceAxisToAxis)
   macro(ExtractDomainToAxis)
   macro(ComputeConnectivityDomain)
@@ -28,4 +29,8 @@
   macro(ExtractAxisToScalar)
   macro(ReduceDomainToScalar)
+  macro(TemporalSplitting)
+  macro(DuplicateScalarToAxis)
+  macro(ReduceScalarToScalar)
+  macro(ReorderDomain)
 
 }
Index: /XIOS/trunk/src/group_template_impl.hpp
===================================================================
--- /XIOS/trunk/src/group_template_impl.hpp	(revision 1536)
+++ /XIOS/trunk/src/group_template_impl.hpp	(revision 1537)
@@ -373,48 +373,78 @@
    void CGroupTemplate<U, V, W>::sendCreateChild(const string& id)
    {
+    CContext* context=CContext::getCurrent() ;  
+
+    if (context->hasClient)
+    // if (!context->hasServer )
+    {
+      // Use correct context client to send message
+//      CContextClient* contextClientTmp = (0 != context->clientPrimServer) ? context->clientPrimServer : context->client;
+      int nbSrvPools = (context->hasServer) ? context->clientPrimServer.size() : 1;
+      for (int i = 0; i < nbSrvPools; ++i)
+      {
+         CContextClient* contextClientTmp = (context->hasServer) ? context->clientPrimServer[i] : context->client;
+
+         CEventClient event(this->getType(),EVENT_ID_CREATE_CHILD) ;
+         if (contextClientTmp->isServerLeader())
+         {
+           CMessage msg ;
+           msg<<this->getId() ;
+           msg<<id ;
+           const std::list<int>& ranks = contextClientTmp->getRanksServerLeader();
+           for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
+             event.push(*itRank,1,msg) ;
+           contextClientTmp->sendEvent(event) ;
+         }
+         else contextClientTmp->sendEvent(event) ;
+      }
+    }
+      
+   }
+
+   template <class U, class V, class W>
+   void CGroupTemplate<U, V, W>::sendCreateChild(const string& id, CContextClient* client)
+   {
+
+    CEventClient event(this->getType(),EVENT_ID_CREATE_CHILD) ;
+    if (client->isServerLeader())
+    {
+      CMessage msg ;
+      msg<<this->getId() ;
+      msg<<id ;
+      const std::list<int>& ranks = client->getRanksServerLeader();
+      for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
+       event.push(*itRank,1,msg) ;
+      client->sendEvent(event) ;
+    }
+    else client->sendEvent(event) ;
+   }
+
+
+   template <class U, class V, class W>
+   void CGroupTemplate<U, V, W>::sendCreateChildGroup(const string& id)
+   {
     CContext* context=CContext::getCurrent() ;
-    
-    if (! context->hasServer )
+    if (context->hasClient)
     {
-       CContextClient* client=context->client ;
-
-       CEventClient event(this->getType(),EVENT_ID_CREATE_CHILD) ;   
-       if (client->isServerLeader())
-       {
-         CMessage msg ;
-         msg<<this->getId() ;
-         msg<<id ;
-         const std::list<int>& ranks = client->getRanksServerLeader();
-         for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
-           event.push(*itRank,1,msg) ;
-         client->sendEvent(event) ;
-       }
-       else client->sendEvent(event) ;
+      // Use correct context client to send message
+      // int nbSrvPools = (context->hasServer) ? context->clientPrimServer.size() : 1;
+      int nbSrvPools = (context->hasServer) ? (context->hasClient ? context->clientPrimServer.size() : 1) : 1;
+      for (int i = 0; i < nbSrvPools; ++i)
+      {
+        CContextClient* contextClientTmp = (context->hasServer) ? context->clientPrimServer[i] : context->client;
+        CEventClient event(this->getType(),EVENT_ID_CREATE_CHILD_GROUP) ;
+        if (contextClientTmp->isServerLeader())
+        {
+          CMessage msg ;
+          msg<<this->getId() ;
+          msg<<id ;
+          const std::list<int>& ranks = contextClientTmp->getRanksServerLeader();
+          for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
+            event.push(*itRank,1,msg) ;
+          contextClientTmp->sendEvent(event) ;
+        }
+        else contextClientTmp->sendEvent(event) ;
+      }
     }
-      
-   }
-   
-   template <class U, class V, class W>
-   void CGroupTemplate<U, V, W>::sendCreateChildGroup(const string& id)
-   {
-    CContext* context=CContext::getCurrent() ;
-    if (! context->hasServer )
-    {
-       CContextClient* client=context->client ;
-
-       CEventClient event(this->getType(),EVENT_ID_CREATE_CHILD_GROUP) ;   
-       if (client->isServerLeader())
-       {
-         CMessage msg ;
-         msg<<this->getId() ;
-         msg<<id ;
-         const std::list<int>& ranks = client->getRanksServerLeader();
-         for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
-           event.push(*itRank,1,msg) ;
-         client->sendEvent(event) ;
-       }
-       else client->sendEvent(event) ;
-    }
-      
    }
    
@@ -422,5 +452,4 @@
    void CGroupTemplate<U, V, W>::recvCreateChild(CEventServer& event)
    {
-      
       CBufferIn* buffer=event.subEvents.begin()->buffer;
       string id;
